﻿# -*- coding: utf-8 -*-


class Client(object):
	SUPPORTED_STATIONS = {
		'picks': [
		{
			'rpID': '222',
			'label': 'LIVE',
			'description': 'Radio Lippewelle Hamm ist das Lokalradio für Hamm. Bei uns hört ihr 24 Stunden am Tag den besten Mix und die wichtigsten Nachrichten aus Hamm und der Welt.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-live.html',
			'audio_url': 'https://stream.lokalradio.nrw/4454253',
			'thumb': 'live.png',
			'route': '1'
		},
		{
			'rpID': '796',
			'label': '80er Radio',
			'description': 'Die größten Hits der 80er im Lieblingsmix.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-80er.html',
			'audio_url': 'https://stream.lokalradio.nrw/444zgn3',
			'thumb': '80er.png',
			'route': '2'
		},
		{
			'rpID': '921',
			'label': '90er Radio',
			'description': 'Die besten Hits der 90er - nonstop!',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-90er.html',
			'audio_url': 'https://stream.lokalradio.nrw/444zjzk',
			'thumb': '90er.png',
			'route': '3'
		},
		{
			'rpID': '2310',
			'label': '2000er Radio',
			'description': 'Die 2000er Jahre (2000 - 2019) waren musikalisch eine sehr aufregende Zeit: Neue Sängerinnen wie Anastacia, Rihanna oder Lady Gaga mischten die Musikszene gewaltig auf und eroberten die Charts.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-2000er.html',
			'audio_url': 'https://stream.lokalradio.nrw/4456wh5',
			'thumb': '2000er.png',
			'route': '4'
		},
		{
			'rpID': '798',
			'label': 'TOP 40 Radio',
			'description': 'Die beliebteste Musik aus den aktuellen Charts.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-top40.html',
			'audio_url': 'https://stream.lokalradio.nrw/44525n3',
			'thumb': 'top40.png',
			'route': '5'
		},
		{
			'rpID': '800',
			'label': 'Urban Radio',
			'description': 'Urbanes Feeling mit den Hits von gestern und heute.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-urban.html',
			'audio_url': 'https://stream.lokalradio.nrw/44527zk',
			'thumb': 'urban.png',
			'route': '6'
		},
		{
			'rpID': '797',
			'label': 'Lounge Radio',
			'description': 'Der beste Mix zum Entspannen und Relaxen.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-lounge.html',
			'audio_url': 'https://stream.lokalradio.nrw/444zt53',
			'thumb': 'lounge.png',
			'route': '7'
		},
		{
			'rpID': '923',
			'label': 'LOVE Radio',
			'description': 'Die schönsten Lovesongs für Verliebte und Lieblingsmenschen.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-love.html',
			'audio_url': 'https://stream.lokalradio.nrw/444zwhk',
			'thumb': 'love.png',
			'route': '8'
		},
		{
			'rpID': '922',
			'label': 'Deutsch-POP Radio',
			'description': 'Der Deutsch-Pop Lieblingsmix.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-deutschpop.html',
			'audio_url': 'https://stream.lokalradio.nrw/444znd3',
			'thumb': 'deutschpop.png',
			'route': '9'
		},
		{
			'rpID': '924',
			'label': 'Schlager Radio',
			'description': 'Alle Hits im besten Schlagermix.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-schlager.html',
			'audio_url': 'https://stream.lokalradio.nrw/445238k',
			'thumb': 'schlager.png',
			'route': '10'
		},
		{
			'rpID': '2311',
			'label': 'Dance Radio',
			'description': 'Alles, was gerade in den angesagtesten Clubs läuft, befindet sich auf Dein Dance Radio. Von Steve Aoki über Meduza zu Camelphat ist hier alles dabei, was aktuell aufgelegt wird.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-dance.html',
			'audio_url': 'https://stream.lokalradio.nrw/4456jhh',
			'thumb': 'dance.png',
			'route': '11'
		},
		{
			'rpID': '2550',
			'label': 'Hip Hop Radio',
			'description': 'Alles was in der Hip Hop - Szene gerade angesagt ist.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-hiphop.html',
			'audio_url': 'https://stream.lokalradio.nrw/4458bt3',
			'thumb': 'hiphop.png',
			'route': '12'
		},
		{
			'rpID': '799',
			'label': 'Rock Radio',
			'description': 'Der beste Rockmix.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-rock.html',
			'audio_url': 'https://stream.lokalradio.nrw/444zyw3',
			'thumb': 'rock.png',
			'route': '13'
		},
		{
			'rpID': '2548',
			'label': 'Rock-Classic Radio',
			'description': 'Der Rockmix in der Classic Variante.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-rock-classic.html',
			'audio_url': 'https://stream.lokalradio.nrw/44578gs',
			'thumb': 'classic.png',
			'route': '14'
		},
		{
			'rpID': '1822',
			'label': 'Oldie Radio',
			'description': '60er, 70er & 80er nonstop: Das ist das Radio für alle Dancing Queens und Moviestars. Mit Flowerpower-Garantie, den Discohits für jede Party und den Mega-Stars, die unvergessen bleiben.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-oldie.html',
			'audio_url': 'https://stream.lokalradio.nrw/44548bb',
			'thumb': 'oldie.png',
			'route': '15'
		},
		{
			'rpID': '2549',
			'label': 'New-Country Radio',
			'description': 'Neue Countrymusik beliebt bei alt und jung.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-new-country.html',
			'audio_url': 'https://stream.lokalradio.nrw/4457ytf',
			'thumb': 'country.png',
			'route': '16'
		},
		{
			'rpID': '2312',
			'label': 'Singer-Songwriter Radio',
			'description': 'Singer/Songwriter stehen hoch im Kurs. Spätestens seit Ed Sheeran sind Musiker, die sich einfach mit der Gitarre auf die Bühne stellen, total angesagt. Handgemachte Musik mit poetischen Texten ist...',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-singer.html',
			'audio_url': 'https://stream.lokalradio.nrw/44566hv',
			'thumb': 'singer.png',
			'route': '17'
		},
		{
			'rpID': '1821',
			'label': 'KARNEVALS Radio',
			'description': 'Das Radio mit Partygarantie: Die fünfte Jahreszeit - rund um die Uhr. Hier gibt es alle jecken Hits und die besten Partykracher. Feiert mit... nicht nur zu Karneval.',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-karneval.html',
			'audio_url': 'https://stream.lokalradio.nrw/4454bpt',
			'thumb': 'karneval.png',
			'route': '18'
		},
		{
			'rpID': '925',
			'label': 'WEIHNACHTS Radio',
			'description': 'Der beste Weihnachtsmix für die schönste Zeit des Jahres. „Driving home for christmas – In der Weihnachtsbäckerei“. Von Wham bis Sinatra, von Mariah Carey bis Elvis!',
			'iframe_url': 'https://www.lippewelle.de/service/radioplayer/inhalte-xmas.html',
			'audio_url': 'https://stream.lokalradio.nrw/444zqrk',
			'thumb': 'xmas.png',
			'route': '19'
		}]
	}

	def __init__(self, config):
		self._config = config

	def get_config(self):
		return self._config
